﻿public class Program {

	private static async Task<int> OneAsync(int value) {
		try {
			if (value < 0) {
				throw new ArgumentOutOfRangeException(nameof(value));
			}

			Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: OneAsync before first await ...");
			await Task.Delay(100);
			Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: OneAsync after first await ...");

			throw new InvalidOperationException();

		} catch (Exception ex) {
			Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: OneAsync throwing {ex.GetType()}: {ex.Message} ...");
			throw;
		}
	}
	
	public static void Main(string[] args) {

		for (int i = -1; i <= 0; i++) {

			Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Main C.WL() 1: calling OneAsync({i}) ...");
			Task<int>? task = null;
			try {
				task = OneAsync(i);

				Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Main C.WL() 2: got Task<int> with Status: {task.Status}");
				if (task.Status == TaskStatus.Faulted) {
					Console.WriteLine($"    task.Exception == {task.Exception!.GetType()}:");
					Console.WriteLine($"        \"{task.Exception.Message}\"");
				}
			} catch (Exception ex) {
				Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Main C.WL() 3: caught exception: {ex}");
			}

			if (task is not null) {
				Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Main C.WL() 4: calling task.Result getter ...");
				try {
					var result = task.Result;
				} catch (Exception ex) {
					Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Main C.WL() 5: caught exception: {ex}");
				}
			}

            Console.WriteLine();
        }
	}
}
